/* 
 * Sound Monitor applet for the GNOME panel
 * (C) 2002 John Ellis
 *
 * Author: John Ellis
 *
 * This software is released under the GNU General Public License (GNU GPL).
 * Please read the included file COPYING for more information.
 * This software comes with no warranty of any kind, use at your own risk!
 */


#ifndef TYPEDEFS_H
#define TYPEDEFS_H

/* input rate */
#define RATE   44100

/* buffer size */
#define NSAMP  2048

typedef struct _SoundData SoundData;
struct _SoundData
{
	gint fd;
	gint input_cb_id;
	short *buffer;
	guint buffer_count;
	guint buffer_current;
	gint latency;
	gint left;
	gint right;
	gint new_data;
	gchar *host;

	/* latency stuff */
	gint check_id;
	gint check_speed;
	gint read_data;
	gint read_count;
};

typedef enum {
        PeakMode_Off,
        PeakMode_Active,
        PeakMode_Smooth
} PeakModeType;

enum {
	SIZEHINT_TINY,
	SIZEHINT_SMALL,
	SIZEHINT_STANDARD,
	SIZEHINT_LARGE,
	SIZEHINT_HUGE
};

typedef enum {
	Status_Error,
	Status_Standby,
	Status_AutoStandby,
	Status_Ready
} StatusType;

typedef enum {
	Control_Start,
	Control_Standby,
	Control_Resume
} ControlType;

typedef struct _AppData AppData;
struct _AppData
{
	PanelApplet *applet;

	PanelAppletOrient orient;
	gint sizehint;
	gint update_timeout_id;

	gchar *theme_file;
	gint refresh_fps;

	StatusType esd_status;
	StatusType esd_status_menu;

	PeakModeType peak_mode;
	gint falloff_speed;

	gint scope_scale;

	SoundData *sound;

	gchar *esd_host;
	gint monitor_input;

	gint prev_vu_changed;

	gint no_data_count;
	gint status_check_count;
	gint scope_flat;
	gint draw_scope_as_segments;

	gint latency;

	/* the properties window widgets */
	GtkWidget *propwindow;
	GtkWidget *theme_entry;
	GtkWidget *host_entry;

	UIData *ui;

	gint has_scope;
	gint has_meter;
	gint has_spectrum;

	gpointer manager;
};

#endif

